<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { ActionMode } from "../actionUtils";
  import HintAction from "./HintAction.svelte";

  const dispatchEvent = createEventDispatcher();
  function dispatchChangeMode(mode: ActionMode | null): void {
    dispatchEvent("changeMode", mode);
  }

  export let userId: PlayerId;
  export let state: GameState;
  export let mode: ActionMode | null;
</script>

<section>
  {#if mode === null}
    <button
      class="secondary"
      disabled={state.hints === 8}
      title={state.hints === 8
        ? "Cannot discard when you already have 8 hints."
        : ""}
      on:click={() => dispatchChangeMode(ActionMode.Discarding)}
    >
      Discard card
    </button>
    <button
      class="secondary"
      on:click={() => dispatchChangeMode(ActionMode.Hinting)}
    >
      Give hint
    </button>
    <button
      class="primary"
      on:click={() => dispatchChangeMode(ActionMode.Playing)}
    >
      Play card
    </button>
  {:else if mode === ActionMode.Discarding || mode === ActionMode.Playing}
    <button class="secondary" on:click={() => dispatchChangeMode(null)}>
      Cancel
    </button>
  {:else if mode === ActionMode.Hinting}
    <div class="hinting panel shadow border">
      <HintAction {state} {userId} on:action on:changeMode />
    </div>
  {/if}
</section>

<style>
  section {
    display: flex;
    flex-wrap: nowrap;
    min-width: 20em;
    justify-content: center;
  }
  button {
    margin-inline-start: 0.2em;
    margin-inline-end: 0.2em;
    white-space: nowrap;
  }
  .hinting {
    width: 100%;
  }
</style>
